unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, Dxcore,
  activex;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_ZZJWLRKList, U_ZZJWLOutList, U_ShaKCListJWL, U_ShaKCHZListJWL,
  U_WeiXiuList, U_ZZJWLOutHZList, U_JWLOrderList, U_JWLcktjlist;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmShaRKListRKJWL, frmShaRKListGQXJWL, frmShaRKListViewJWL: TfrmZZJWLRKList;
  frmShaOutListCKJWL, frmShaOutListGQXJWL, frmShaOutListViewJWL: TfrmZZJWLOutList;
  frmJWLOrderListGL, frmJWLOrderListCX: TfrmJWLOrderList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);
  server := '47.100.130.130,7781';
//  server := '.';
  dtbase := 'zhenyongdata';
//  dtbase := 'cszhenyong';
  user := 'zhenyongsa';
  pswd := 'rightsoft@9101';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
   DConString := DataBaseStr;
  // DName:='周高祥';
//   DParameters1:='高权限';   //高权限
   //DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    1:  //机物料出库统计报表
      begin
        if frmJWLcktjlist = nil then
        begin
          frmJWLcktjlist := TfrmJWLcktjlist.Create(application.MainForm);
          with frmJWLcktjlist do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJWLcktjlist.BringToFront;
       //句柄
        mnewHandle := frmJWLcktjlist.Handle;
      end;
    401:  //维修记录
      begin
        if frmWeiXiuList = nil then
        begin
          frmWeiXiuList := TfrmWeiXiuList.Create(application.MainForm);
          with frmWeiXiuList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWeiXiuList.BringToFront;
       //句柄
        mnewHandle := frmWeiXiuList.Handle;
      end;

    12:  //辅料指示单管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '辅料指示单管理' then
          begin
            BringWindowToTop(frmJWLOrderListgl.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmJWLOrderListgl := TfrmJWLOrderList.Create(application.MainForm);
          with frmJWLOrderListgl do
          begin
            canshu1 := '高权限';
            Title := '辅料指示单管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJWLOrderListgl.BringToFront;
       //句柄
        mnewHandle := frmJWLOrderListgl.Handle;
      end;
    101:  //机物料入库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料入库管理' then
          begin
            BringWindowToTop(frmShaRKListRKJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListRKJWL := TfrmZZJWLRKList.Create(application.MainForm);
          with frmShaRKListRKJWL do
          begin
            Title := '机物料入库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListRKJWL.BringToFront;
       //句柄
        mnewHandle := frmShaRKListRKJWL.Handle;
      end;
    102:  //机物料入库管理(高权限)
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料入库管理(高权限)' then
          begin
            BringWindowToTop(frmShaRKListGQXJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListGQXJWL := TfrmZZJWLRKList.Create(application.MainForm);
          with frmShaRKListGQXJWL do
          begin
            Title := '机物料入库管理(高权限)';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListGQXJWL.BringToFront;
       //句柄
        mnewHandle := frmShaRKListGQXJWL.Handle;
      end;
    103:  //机物料入库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料入库查询' then
          begin
            BringWindowToTop(frmShaRKListViewJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListViewJWL := TfrmZZJWLRKList.Create(application.MainForm);
          with frmShaRKListViewJWL do
          begin
            Title := '机物料入库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListViewJWL.BringToFront;
       //句柄
        mnewHandle := frmShaRKListViewJWL.Handle;
      end;
    104:  //机物料入库单价修改
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料入库单价修改' then
          begin
            BringWindowToTop(frmShaRKListViewJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaRKListViewJWL := TfrmZZJWLRKList.Create(application.MainForm);
          with frmShaRKListViewJWL do
          begin
            Title := '机物料入库单价修改';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaRKListViewJWL.BringToFront;
       //句柄
        mnewHandle := frmShaRKListViewJWL.Handle;
      end;
    201:  //机物料出库管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料出库管理' then
          begin
            BringWindowToTop(frmShaOutListCKJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaOutListCKJWL := TfrmZZJWLOutList.Create(application.MainForm);
          with frmShaOutListCKJWL do
          begin
            Title := '机物料出库管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutListCKJWL.BringToFront;
       //句柄
        mnewHandle := frmShaOutListCKJWL.Handle;
      end;
    202:  //机物料出库管理(高权限)
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料出库管理(高权限)' then
          begin
            BringWindowToTop(frmShaOutListGQXJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaOutListGQXJWL := TfrmZZJWLOutList.Create(application.MainForm);
          with frmShaOutListGQXJWL do
          begin
            Title := '机物料出库管理(高权限)';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutListGQXJWL.BringToFront;
       //句柄
        mnewHandle := frmShaOutListGQXJWL.Handle;
      end;
    203:  //机物料出库查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '机物料出库查询' then
          begin
            BringWindowToTop(frmShaOutListViewJWL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
       //if frmBaoGuanListBGZL=nil then
        begin
          frmShaOutListViewJWL := TfrmZZJWLOutList.Create(application.MainForm);
          with frmShaOutListViewJWL do
          begin
            Title := '机物料出库查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaOutListViewJWL.BringToFront;
       //句柄
        mnewHandle := frmShaOutListViewJWL.Handle;
      end;
    211:  //机物料出库汇总
      begin
        if frmZZJWLOutHZList = nil then
        begin
          frmZZJWLOutHZList := TfrmZZJWLOutHZList.Create(application.MainForm);
          with frmZZJWLOutHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmZZJWLOutHZList.BringToFront;
       //句柄
        mnewHandle := frmZZJWLOutHZList.Handle;
      end;
    301:  //机物料库存
      begin
        if frmShaKCListJWL = nil then
        begin
          frmShaKCListJWL := TfrmShaKCListJWL.Create(application.MainForm);
          with frmShaKCListJWL do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaKCListJWL.BringToFront;
       //句柄
        mnewHandle := frmShaKCListJWL.Handle;
      end;
    302:  //机物料库存汇总查询
      begin
        if frmShaKCHZListJWL = nil then
        begin
          frmShaKCHZListJWL := TfrmShaKCHZListJWL.Create(application.MainForm);
          with frmShaKCHZListJWL do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmShaKCHZListJWL.BringToFront;
       //句柄
        mnewHandle := frmShaKCHZListJWL.Handle;
      end;
  end;  // end case

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_GYJWL) then
    DataLink_GYJWL := TDataLink_GYJWL.Create(Application);
  try
    with DataLink_GYJWL.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_GYJWL.Free;
//  Application := OldDllApp;
initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_GYJWL.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

